const { NestFactory } = require("@nestjs/core")
const { AppModule } = require.fromParentEnvironment("./dist/app.module")
const { ExpressAdapter } = require("@nestjs/platform-express")
const express = require("express")
const { createServer, proxy } = require("tencent-serverless-http")

let cachedServer

const bootstrapServer = async () => {
  const expressApp = express()
  const adapter = new ExpressAdapter(expressApp)
  console.log('AppModule:', AppModule)
  const app = await NestFactory.create(AppModule, adapter)
  app.enableCors()
  await app.init()
  return createServer(expressApp)
}

module.exports.handler = async (event, context) => {
  if (!cachedServer) {
    const server = await bootstrapServer()
    cachedServer = server;
    return proxy(server, event, context, 'PROMISE').promise
  } else {
    return proxy(cachedServer, event, context, 'PROMISE').promise
  }
}